package tests;

import org.junit.*;
import static org.junit.Assert.*;

import javax.tools.*;
import java.util.*;

import com.sun.source.tree.*;

/**
 * JUnit tests for the NonNull annotation checker.
 */
public class NonNullTest extends CheckerTest {

    public NonNullTest() {
        checkerName = "checkers.nonnull.NonnullChecker";
        checkerDir = "nonnull";
    }

    /** Tests for flow-sensitive analysis. */
    @Test public void testFlow() {
        TestRun run = getTest("Flow.java");
        assertFailure(run);
        List<Diagnostic<? extends JavaFileObject>> list = run.getDiagnostics();
        assertDiagnostics(list, "Flow.out");
    }

    /** Tests that crashes do not occur for varargs methods. */
    @Test public void testVarargs() {
        TestRun run = getTest("Varargs.java");
        assertSuccess(run);
        List<Diagnostic<? extends JavaFileObject>> list = run.getDiagnostics();
        assertDiagnostics(list, "Varargs.out");
    }
}
